# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cdp.openapi_client.models.abi_parameter import AbiParameter
from cdp.openapi_client.models.abi_state_mutability import AbiStateMutability
from typing import Optional, Set
from typing_extensions import Self

class AbiFunction(BaseModel):
    """
    ABI function type for contract functions.
    """ # noqa: E501
    type: StrictStr = Field(description="The type of the ABI item, must be `function`.")
    name: StrictStr = Field(description="The name of the ABI function.")
    inputs: List[AbiParameter] = Field(description="The list of ABI parameters used for this function.")
    outputs: List[AbiParameter] = Field(description="The values returned by this function.")
    constant: Optional[StrictBool] = Field(default=None, description="Deprecated. Use pure or view from stateMutability instead.")
    payable: Optional[StrictBool] = Field(default=None, description="Deprecated. Use payable or nonpayable from `stateMutability` instead.")
    state_mutability: AbiStateMutability = Field(alias="stateMutability")
    gas: Optional[StrictInt] = Field(default=None, description="Deprecated. Vyper used to provide gas estimates.")
    __properties: ClassVar[List[str]] = ["type", "name", "inputs", "outputs", "constant", "payable", "stateMutability", "gas"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['function']):
            raise ValueError("must be one of enum values ('function')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AbiFunction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in inputs (list)
        _items = []
        if self.inputs:
            for _item_inputs in self.inputs:
                if _item_inputs:
                    _items.append(_item_inputs.to_dict())
            _dict['inputs'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in outputs (list)
        _items = []
        if self.outputs:
            for _item_outputs in self.outputs:
                if _item_outputs:
                    _items.append(_item_outputs.to_dict())
            _dict['outputs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AbiFunction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "name": obj.get("name"),
            "inputs": [AbiParameter.from_dict(_item) for _item in obj["inputs"]] if obj.get("inputs") is not None else None,
            "outputs": [AbiParameter.from_dict(_item) for _item in obj["outputs"]] if obj.get("outputs") is not None else None,
            "constant": obj.get("constant"),
            "payable": obj.get("payable"),
            "stateMutability": obj.get("stateMutability"),
            "gas": obj.get("gas")
        })
        return _obj


