# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from cdp.openapi_client.models.common_swap_response_issues_allowance import CommonSwapResponseIssuesAllowance
from cdp.openapi_client.models.common_swap_response_issues_balance import CommonSwapResponseIssuesBalance
from typing import Optional, Set
from typing_extensions import Self

class CommonSwapResponseIssues(BaseModel):
    """
    An object containing potential issues discovered during validation that could prevent the swap from being executed successfully.
    """ # noqa: E501
    allowance: Optional[CommonSwapResponseIssuesAllowance]
    balance: Optional[CommonSwapResponseIssuesBalance]
    simulation_incomplete: StrictBool = Field(description="This is set to true when the transaction cannot be validated. This can happen when the taker has an insufficient balance of the `fromToken`. Note that this does not necessarily mean that the trade will revert.", alias="simulationIncomplete")
    __properties: ClassVar[List[str]] = ["allowance", "balance", "simulationIncomplete"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CommonSwapResponseIssues from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of allowance
        if self.allowance:
            _dict['allowance'] = self.allowance.to_dict()
        # override the default output from pydantic by calling `to_dict()` of balance
        if self.balance:
            _dict['balance'] = self.balance.to_dict()
        # set to None if allowance (nullable) is None
        # and model_fields_set contains the field
        if self.allowance is None and "allowance" in self.model_fields_set:
            _dict['allowance'] = None

        # set to None if balance (nullable) is None
        # and model_fields_set contains the field
        if self.balance is None and "balance" in self.model_fields_set:
            _dict['balance'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CommonSwapResponseIssues from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "allowance": CommonSwapResponseIssuesAllowance.from_dict(obj["allowance"]) if obj.get("allowance") is not None else None,
            "balance": CommonSwapResponseIssuesBalance.from_dict(obj["balance"]) if obj.get("balance") is not None else None,
            "simulationIncomplete": obj.get("simulationIncomplete")
        })
        return _obj


