# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cdp.openapi_client.models.error_type import ErrorType
from typing import Optional, Set
from typing_extensions import Self

class Error(BaseModel):
    """
    An error response including the code for the type of error and a human-readable message describing the error.
    """ # noqa: E501
    error_type: ErrorType = Field(alias="errorType")
    error_message: StrictStr = Field(description="The error message.", alias="errorMessage")
    correlation_id: Optional[StrictStr] = Field(default=None, description="A unique identifier for the request that generated the error. This can be used to help debug issues with the API.", alias="correlationId")
    error_link: Optional[StrictStr] = Field(default=None, description="A link to the corresponding error documentation.", alias="errorLink")
    __properties: ClassVar[List[str]] = ["errorType", "errorMessage", "correlationId", "errorLink"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Error from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Error from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "errorType": obj.get("errorType"),
            "errorMessage": obj.get("errorMessage"),
            "correlationId": obj.get("correlationId"),
            "errorLink": obj.get("errorLink")
        })
        return _obj


