# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cdp.openapi_client.models.evm_data_parameter_condition import EvmDataParameterCondition
from cdp.openapi_client.models.evm_data_parameter_condition_list import EvmDataParameterConditionList
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

EVMDATACONDITIONPARAMSINNER_ONE_OF_SCHEMAS = ["EvmDataParameterCondition", "EvmDataParameterConditionList"]

class EvmDataConditionParamsInner(BaseModel):
    """
    A list of parameter conditions to apply against encoded arguments in the transaction's `data` field.
    """
    # data type: EvmDataParameterCondition
    oneof_schema_1_validator: Optional[EvmDataParameterCondition] = None
    # data type: EvmDataParameterConditionList
    oneof_schema_2_validator: Optional[EvmDataParameterConditionList] = None
    actual_instance: Optional[Union[EvmDataParameterCondition, EvmDataParameterConditionList]] = None
    one_of_schemas: Set[str] = { "EvmDataParameterCondition", "EvmDataParameterConditionList" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = EvmDataConditionParamsInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: EvmDataParameterCondition
        if not isinstance(v, EvmDataParameterCondition):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmDataParameterCondition`")
        else:
            match += 1
        # validate data type: EvmDataParameterConditionList
        if not isinstance(v, EvmDataParameterConditionList):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmDataParameterConditionList`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in EvmDataConditionParamsInner with oneOf schemas: EvmDataParameterCondition, EvmDataParameterConditionList. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in EvmDataConditionParamsInner with oneOf schemas: EvmDataParameterCondition, EvmDataParameterConditionList. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into EvmDataParameterCondition
        try:
            instance.actual_instance = EvmDataParameterCondition.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmDataParameterConditionList
        try:
            instance.actual_instance = EvmDataParameterConditionList.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into EvmDataConditionParamsInner with oneOf schemas: EvmDataParameterCondition, EvmDataParameterConditionList. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into EvmDataConditionParamsInner with oneOf schemas: EvmDataParameterCondition, EvmDataParameterConditionList. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EvmDataParameterCondition, EvmDataParameterConditionList]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


