# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from cdp.openapi_client.models.payment_method_limits_source_limit import PaymentMethodLimitsSourceLimit
from cdp.openapi_client.models.payment_method_limits_target_limit import PaymentMethodLimitsTargetLimit
from typing import Optional, Set
from typing_extensions import Self

class PaymentMethodLimits(BaseModel):
    """
    The limits of the payment method.
    """ # noqa: E501
    source_limit: Optional[PaymentMethodLimitsSourceLimit] = Field(default=None, alias="sourceLimit")
    target_limit: Optional[PaymentMethodLimitsTargetLimit] = Field(default=None, alias="targetLimit")
    __properties: ClassVar[List[str]] = ["sourceLimit", "targetLimit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentMethodLimits from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source_limit
        if self.source_limit:
            _dict['sourceLimit'] = self.source_limit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target_limit
        if self.target_limit:
            _dict['targetLimit'] = self.target_limit.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentMethodLimits from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceLimit": PaymentMethodLimitsSourceLimit.from_dict(obj["sourceLimit"]) if obj.get("sourceLimit") is not None else None,
            "targetLimit": PaymentMethodLimitsTargetLimit.from_dict(obj["targetLimit"]) if obj.get("targetLimit") is not None else None
        })
        return _obj


