# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cdp.openapi_client.models.eth_value_criterion import EthValueCriterion
from cdp.openapi_client.models.evm_address_criterion import EvmAddressCriterion
from cdp.openapi_client.models.evm_data_criterion import EvmDataCriterion
from cdp.openapi_client.models.evm_network_criterion import EvmNetworkCriterion
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SENDEVMTRANSACTIONCRITERIAINNER_ONE_OF_SCHEMAS = ["EthValueCriterion", "EvmAddressCriterion", "EvmDataCriterion", "EvmNetworkCriterion"]

class SendEvmTransactionCriteriaInner(BaseModel):
    """
    SendEvmTransactionCriteriaInner
    """
    # data type: EthValueCriterion
    oneof_schema_1_validator: Optional[EthValueCriterion] = None
    # data type: EvmAddressCriterion
    oneof_schema_2_validator: Optional[EvmAddressCriterion] = None
    # data type: EvmNetworkCriterion
    oneof_schema_3_validator: Optional[EvmNetworkCriterion] = None
    # data type: EvmDataCriterion
    oneof_schema_4_validator: Optional[EvmDataCriterion] = None
    actual_instance: Optional[Union[EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion]] = None
    one_of_schemas: Set[str] = { "EthValueCriterion", "EvmAddressCriterion", "EvmDataCriterion", "EvmNetworkCriterion" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SendEvmTransactionCriteriaInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: EthValueCriterion
        if not isinstance(v, EthValueCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EthValueCriterion`")
        else:
            match += 1
        # validate data type: EvmAddressCriterion
        if not isinstance(v, EvmAddressCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmAddressCriterion`")
        else:
            match += 1
        # validate data type: EvmNetworkCriterion
        if not isinstance(v, EvmNetworkCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmNetworkCriterion`")
        else:
            match += 1
        # validate data type: EvmDataCriterion
        if not isinstance(v, EvmDataCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmDataCriterion`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SendEvmTransactionCriteriaInner with oneOf schemas: EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SendEvmTransactionCriteriaInner with oneOf schemas: EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into EthValueCriterion
        try:
            instance.actual_instance = EthValueCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmAddressCriterion
        try:
            instance.actual_instance = EvmAddressCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmNetworkCriterion
        try:
            instance.actual_instance = EvmNetworkCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmDataCriterion
        try:
            instance.actual_instance = EvmDataCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SendEvmTransactionCriteriaInner with oneOf schemas: EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SendEvmTransactionCriteriaInner with oneOf schemas: EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EthValueCriterion, EvmAddressCriterion, EvmDataCriterion, EvmNetworkCriterion]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


